﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace app_plus
{
    class Program
    {
        static void Main(string[] args)
        {
            // TestCash();
            TestUpload();
        }

     
		//文件上传demo
        static void TestUpload()
        {
            string url = "https://hfpay.testpnr.com/api/alse/file01";
            string version = "10";
            string mer_cust_id = "6666000000002619";
            string attach_no = "abcd" + DateTime.Now.Ticks.ToString("x");
            string file_name = "test.png";
            string file_path = "C:\\" + file_name;
			

            Dictionary<string, string> info = new Dictionary<string, string>();
            info.Add("version", version);
            info.Add("mer_cust_id", mer_cust_id);
            info.Add("attach_no", attach_no);
            info.Add("trans_type", "3");
            info.Add("attach_type", "1");

            string json_string = JsonConvert.SerializeObject(info, Formatting.None);
            Sign sg = new Sign();
            string check_value = sg.sign(json_string);

            string boundary = "ABCD" + DateTime.Now.Ticks.ToString("x");
            byte[] firstBoundaryBytes = System.Text.Encoding.ASCII.GetBytes("--" + boundary + "\r\n");
            byte[] boundaryBytes = System.Text.Encoding.ASCII.GetBytes("\r\n--" + boundary + "\r\n");
            byte[] endBoundaryBytes = System.Text.Encoding.ASCII.GetBytes("\r\n--" + boundary + "--");

            string url_with_param = url;
            bool concat_start = true;
            foreach (var key in info.Keys)
            {
                if (concat_start)
                {
                    url_with_param += "?";
                    concat_start = false;
                }
                else
                {
                    url_with_param += "&";
                }
                url_with_param += key + "=" + info[key];
            }
            url_with_param += "&check_value=" + check_value;
            HttpWebRequest request = request = (HttpWebRequest)WebRequest.Create(url_with_param);
            request.Method = "post";
            request.ContentType = "multipart/form-data; boundary=" + boundary;


            string formItem;
            byte[] formItemBytes;
            Stream memStream = new System.IO.MemoryStream();
            
            memStream.Write(firstBoundaryBytes, 0, firstBoundaryBytes.Length);
            formItem = "Content-Disposition: form-data; " +
                "name=\"attach_file\"; " +
                "filename=\"" + file_name + "\"\r\n" +
                "Content-Type: image/png\r\n\r\n";
            formItemBytes = System.Text.Encoding.UTF8.GetBytes(formItem);
            memStream.Write(formItemBytes, 0, formItemBytes.Length);
            using (var fileStream = new FileStream(file_path, FileMode.Open, FileAccess.Read))
            {
                byte[] buffer = new byte[1024];
                int bytesRead = 0;
                while ((bytesRead = fileStream.Read(buffer, 0, buffer.Length)) != 0)
                {
                    memStream.Write(buffer, 0, bytesRead);
                }
            }
            memStream.Write(endBoundaryBytes, 0, endBoundaryBytes.Length);
            request.ContentLength = memStream.Length;

            using (var requestStream = request.GetRequestStream())
            {
                memStream.Position = 0;
                byte[] tempBuffer = new byte[memStream.Length];
                memStream.Read(tempBuffer, 0, tempBuffer.Length);
                memStream.Close();
                requestStream.Write(tempBuffer, 0, tempBuffer.Length);
            }

            string responseText = null;
            try
            {
                HttpWebResponse httpResponse = (HttpWebResponse)request.GetResponse();
                using (StreamReader streamReader = new StreamReader(httpResponse.GetResponseStream()))
                {
                    responseText = streamReader.ReadToEnd();
                    Dictionary<string, string> responseJson = (Dictionary<string, string>)JsonConvert.DeserializeObject<Dictionary<string, string>>(responseText);
                    responseText = responseJson["check_value"];
                    responseText = sg.unsign(responseText);
                }
            }
            catch (WebException e)
            {
                if (e.Response != null)
                {
                    using (var errorResponse = (HttpWebResponse)e.Response)
                    {
                        using (var reader = new StreamReader(errorResponse.GetResponseStream()))
                        {
                            responseText = reader.ReadToEnd();
                        }
                    }

                }
            }
            Console.WriteLine(responseText);
            while (true) ;
        }
		//取现demo
        static void TestCash()
        {
            string url = "https://hfpay.testpnr.com/api/acou/cash01";
            string version = "10";
            string mer_cust_id = "6666000000002619";

            Dictionary<string, string> info = new Dictionary<string, string>();
            info.Add("version", version);
            info.Add("mer_cust_id", mer_cust_id);
            info.Add("user_cust_id", "6666000000002619");
            info.Add("order_date", "20181026");
            info.Add("order_id", "201673233703");
            info.Add("trans_amt", "0.39");
            info.Add("cash_type", "T1");
            info.Add("bg_ret_url", "https://www.baidu.com");
			info.Add("dev_info_json","{'ipAddr':'10.99.195.11','devType':'1'}");
		

            string json_string = JsonConvert.SerializeObject(info, Formatting.None);
            Sign sg = new Sign();
            string check_value = sg.sign(json_string);
            json_string = sg.unsign(check_value);

            HttpWebRequest request = request = (HttpWebRequest)WebRequest.Create(url);
            request.Method = "post";
            request.ContentType = "application/x-www-form-urlencoded";

            using (var streamWriter = new StreamWriter(request.GetRequestStream()))
            {
                string requestText = "version=" + version + "&" +
                    "mer_cust_id=" + mer_cust_id + "&" +
                    "check_value=" + check_value;
                
                streamWriter.Write(requestText);
                streamWriter.Flush();
                streamWriter.Close();
            }

            string responseText = null;
            try
            {
                HttpWebResponse httpResponse = (HttpWebResponse)request.GetResponse();
                using (StreamReader streamReader = new StreamReader(httpResponse.GetResponseStream()))
                {
                    responseText = streamReader.ReadToEnd();
                    Dictionary<string, string> responseJson = (Dictionary<string, string>)JsonConvert.DeserializeObject<Dictionary<string, string>>(responseText);
                    responseText = responseJson["check_value"];
                    responseText = sg.unsign(responseText);
                }
            } catch (WebException e) {
                if (e.Response != null) {
                    using (var errorResponse = (HttpWebResponse)e.Response)
                    {
                        using (var reader = new StreamReader(errorResponse.GetResponseStream()))
                        {
                            responseText = reader.ReadToEnd();
                        }
                    }
                }
            }
            Console.WriteLine(responseText);
            while (true) ;
        }
    }
}
