﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace app_plus
{
    class Sign
    {
        [DllImport("C:\\SADK.Standard.x64.dll")]
        public static extern int Initialize();
        [DllImport("C:\\SADK.Standard.x64.dll")]
        public static extern int SignData_PKCS7Attached(string strAlgorithm,
                                                byte[] pbySourceData,
                                                int nSourceSize,
                                                string strPFXFilePath,
                                                string strPFXPassword,
                                                string strHashAlg,
                                                ref IntPtr ppstrBase64PKCS7Signature);
        [DllImport("C:\\SADK.Standard.x64.dll")]
        public static extern int VerifyDataSignature_PKCS7Attached(string strAlgorithm,
                                                                   string strBase64PKCS7AttachedSignature,
                                                                   ref IntPtr pptrBase64SignCertContent,
                                                                   ref IntPtr pptrSourceData,
                                                                   ref int pnSourceDataSize);
        [DllImport("C:\\SADK.Standard.x64.dll")]
        public static extern int Uninitialize();
        [DllImport("C:\\SADK.Standard.x64.dll")]
        public static extern void FreeMemory(IntPtr ptrBuf);

        public Sign()
        {
            Initialize();
        }

        public string sign(string plain_text)
        {
            int nResult = 0;
            string strAlgorithm = "RSA";
            byte[] sourceData = null;
            //string strPFXFilePath = "C:/888888-汇付测试商户.pfx";
            //string strPFXPassword = "888888";
            string strPFXFilePath = "C:/888888-NEW.pfx";
            string strPFXPassword = "123456";
            string strHashAlg = "SHA-256";
            IntPtr ppstrBase64PKCS7Signature = IntPtr.Zero;
            string strBase64PKCS7Signature = "";
            string sign_text = null;

            sourceData = System.Text.Encoding.UTF8.GetBytes(plain_text);
            // string base64_str = System.Convert.ToBase64String(sourceData);
            // sourceData = System.Text.Encoding.UTF8.GetBytes(base64_str);

            nResult = SignData_PKCS7Attached(strAlgorithm,
                                     sourceData,
                                     sourceData.Length,
                                     strPFXFilePath,
                                     strPFXPassword,
                                     strHashAlg,
                                     ref ppstrBase64PKCS7Signature);
            if (nResult == 0)
            {
                strBase64PKCS7Signature = InptrToUTF8String(ppstrBase64PKCS7Signature);
                byte[] bSignText = System.Text.Encoding.UTF8.GetBytes(strBase64PKCS7Signature);
                sign_text = System.Convert.ToBase64String(bSignText);
                FreeMemory(ppstrBase64PKCS7Signature);
            }
            return sign_text;
        }

        ~Sign()
        {
            Uninitialize();
        }

        public string unsign(string sign_text)
        {
            int nResult = 0;
            string strAlgorithm = "RSA";
            string strBase64PKCS1Signature = System.Text.ASCIIEncoding.Default.GetString(Convert.FromBase64String(sign_text));
            IntPtr ptrBase64SignCertContent = IntPtr.Zero;
            string strBase64SignCertContent = "";
            IntPtr ptrSourceData = IntPtr.Zero;
            string strSourceData = "";
            string plain_text = null;
            int nSourceDataSize = 0;

            nResult = VerifyDataSignature_PKCS7Attached(strAlgorithm,
                                                        strBase64PKCS1Signature,
                                                        ref ptrBase64SignCertContent,
                                                        ref ptrSourceData,
                                                        ref nSourceDataSize);
            if (nResult == 0)
            {
                byte[] bData = new byte[nSourceDataSize];
                Marshal.Copy(ptrSourceData, bData, 0, nSourceDataSize);
                strSourceData = Encoding.UTF8.GetString(bData);

                // byte[] bPlainText = System.Convert.FromBase64String(strSourceData);
                // plain_text = System.Text.Encoding.UTF8.GetString(bPlainText);
                plain_text = strSourceData;

                strBase64SignCertContent = InptrToUTF8String(ptrBase64SignCertContent);
                FreeMemory(ptrBase64SignCertContent);
                FreeMemory(ptrSourceData);
            }
            return plain_text;
        }

        static private string InptrToUTF8String(IntPtr ptrData)
        {
            string strData = "";
            byte[] byteData = null;
            int i = 0, nSize = 0;

            while (true)
            {
                if (Marshal.ReadByte(ptrData, i) == '\0')
                {
                    nSize = i;
                    break;
                }
                i++;
            }
            if (0 != nSize)
            {
                byteData = new byte[nSize];
                Marshal.Copy(ptrData, byteData, 0, nSize);
                strData = Encoding.UTF8.GetString(byteData);
            }
            for (int index = 0; index < strData.Length; index++)
            {
                char cr = strData[index];
                if ((cr >= 'A' && cr <= 'Z') ||
                    (cr >= 'a' && cr <= 'z') ||
                    (cr >= '0' && cr <= '9') ||
                    (cr == '+') ||
                    (cr == '/'))
                {
                    continue;
                } else if (cr == '=')
                {
                    if (index < strData.Length-1 && strData[index+1] == '=')
                    {
                        strData = strData.Substring(0, index + 2);
                        break;
                    } else
                    {
                        strData = strData.Substring(0, index + 1);
                        break;
                    }
                } else
                {
                    strData = strData.Substring(0, index);
                    break;
                }
            }
            return strData;
        }
    }
}
